#region Copyright (C) 2003-2015 Stimulsoft
/*
{*******************************************************************}
{																	}
{	Stimulsoft Reports       										}
{																	}
{	Copyright (C) 2003-2015 Stimulsoft     							}
{	ALL RIGHTS RESERVED												}
{																	}
{	The entire contents of this file is protected by U.S. and		}
{	International Copyright Laws. Unauthorized reproduction,		}
{	reverse-engineering, and distribution of all or any portion of	}
{	the code contained in this file is strictly prohibited and may	}
{	result in severe civil and criminal penalties and will be		}
{	prosecuted to the maximum extent possible under the law.		}
{																	}
{	RESTRICTIONS													}
{																	}
{	THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES			}
{	ARE CONFIDENTIAL AND PROPRIETARY								}
{	TRADE SECRETS OF Stimulsoft										}
{																	}
{	CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON		}
{	ADDITIONAL RESTRICTIONS.										}
{																	}
{*******************************************************************}
*/
#endregion Copyright (C) 2003-2015 Stimulsoft

using System;
using System.Windows.Forms;
using System.ComponentModel;
using Stimulsoft.Base.Localization;
using Stimulsoft.Base.Serializing;
using Stimulsoft.Report.Dictionary.Design;
using Stimulsoft.Report.WpfDesign;

namespace Stimulsoft.Report.Dictionary
{
    [TypeConverter(typeof (StiSqlDatabaseConverter))]
    public class StiFirebirdDatabase : StiSqlDatabase
    {
        #region StiService override
        public override string ServiceName
        {
            get
            {
                return StiLocalization.Get("Database", "DatabaseFirebird");
            }
        }
        #endregion

        #region DataAdapter override
        protected override string DataAdapterType
        {
            get
            {
                return "Stimulsoft.Report.Dictionary.StiFirebirdAdapterService";
            }
        }
        #endregion

        public override DialogResult Edit(bool newDatabase)
        {
            StiSqlDatabaseEditWindow form = new StiSqlDatabaseEditWindow(this);
            {
                if (newDatabase) form.Title = StiLocalization.Get("FormDatabaseEdit", "FirebirdNew");
                else form.Title = StiLocalization.Get("FormDatabaseEdit", "FirebirdEdit");

                form.TbName.Text = this.Name;
                form.TbAlias.Text = this.Alias;
                form.TbConnectionString.Text = this.ConnectionString;
                form.Show();

                if (form.DialogResult == true)
                {
                    this.Name = form.TbName.Text;
                    this.Alias = form.TbAlias.Text;
                    this.ConnectionString = form.TbConnectionString.Text;
                }
                return form.DialogResult == true ? DialogResult.OK : DialogResult.Cancel;
            }
        }


        /// <summary>
        /// Creates a new object of the type StiFirebirdDatabase.
        /// </summary>
        public StiFirebirdDatabase()
            : this(string.Empty, string.Empty)
        {
        }


        /// <summary>
        /// Creates a new object of the type StiFirebirdDatabase.
        /// </summary>
        public StiFirebirdDatabase(string name, string connectionString)
            : base(name, connectionString)
        {
        }


        /// <summary>
        /// Creates a new object of the type StiFirebirdDatabase.
        /// </summary>
        public StiFirebirdDatabase(string name, string alias, string connectionString)
            : base(name, alias, connectionString)
        {
        }

        /// <summary>
        /// Creates a new object of the type StiFirebirdDatabase.
        /// </summary>
        public StiFirebirdDatabase(string name, string alias, string connectionString, bool promptUserNameAndpassword)
            : base(name, alias, connectionString, promptUserNameAndpassword)
        {
        }

        /// <summary>
        /// Creates a new object of the type StiFirebirdDatabase.
        /// </summary>
        public StiFirebirdDatabase(string name, string alias, string connectionString, bool promptUserNameAndpassword, string key)
            : base(name, alias, connectionString, promptUserNameAndpassword, key)
        {
        }
    }

}
